#include <bits/stdc++.h>
using namespace std;

#define rep(i,n) for(int i=0; i<(n); ++i)

const int maxn = 1005;
const int K = 100;
typedef long long ll;

int n, m;
int t[maxn][maxn];
int tp[maxn][maxn];
int P[maxn][maxn][K];
int C[maxn][maxn][K];
int W[maxn][maxn][K];

ll res=0;

void transpo() {
	rep(i,n) rep(j,m) tp[j][n-1-i]=t[i][j];
	rep(i,n) rep(j,m) t[i][j]=tp[i][j];
}

void algo() {
	rep(k,K) {
		rep(i,n) {
			P[i][0][k]=t[i][0]==k;
			for(int j=1; j<m; ++j) P[i][j][k]=(t[i][j]==k)+P[i][j-1][k];
		}
		rep(j,m) C[0][j][k]=P[0][j][k];
		for(int i=1; i<n; ++i) rep(j,m) C[i][j][k]=P[i][j][k]+C[i-1][j][k];
		rep(j,m) W[0][j][k]=P[0][j][k];
		for(int i=1; i<n; ++i) rep(j,m) W[i][j][k]=W[i-1][min(j+1,m-1)][k]+P[i][j][k];
	}
	rep(i,n) rep(j,m) {
		int k=t[i][j];
		int beg=1, mid, end=min(n-i+1,m-j+1);
		while(beg+1<end) {
			mid=(beg+end)/2;
			int x=W[i+mid-1][j][k]-(i==0?0:W[i-1][min(j+mid,m-1)][k])-(j==0?0:C[i+mid-1][j-1][k]) + (i>0 && j>0 ? W[i-1][j-1][k] : 0);
			if(x==(mid+1)*mid/2) beg=mid;
			else end=mid;
		}
		if(beg>1) res+=1ll*(beg*beg*(beg-1)/2-beg*(beg-1)*(2*beg-1)/6);
	}
}

int main() {
	cin>>n>>m;
	rep(i,n) {
		string s; cin>>s;
		rep(j,m) {
			int x=s[j]-33;
			t[i][j]=x;
		}
	}
algo();
rep(i,3){transpo(); algo();}
cout<<res<<"\n";

return 0;
}
