#include <bits/stdc++.h>
using namespace std;

typedef long double LD;

const LD INF = 1e9;
LD tf, vf, hf, td, vd, hd;
LD v0;

bool Check (LD t)
{
    LD dmax = (t - td) * vd;
    LD hmax = min(hd, v0 * (t - td) - 3 * (td - t) * (td - t) / 2);
    if (hmax < 0)
        hmax = 0;
    LD d = (t - tf) * vf;
    LD h = max((LD)0, hf - (t - tf) * (t - tf) / 2);

    return (dmax >= d && hmax >= h);
}

int main ()
{
    scanf("%Lf %Lf %Lf %Lf %Lf %Lf", &tf, &vf, &hf, &td, &vd, &hd);

    LD eps = 0.000001, L = td, R = INF;

    LD t = sqrt(hd * 2 / 3);
    v0 = hd * 2 / t;

    while (L + eps < R)
    {
        LD M = (L + R) * (LD)0.5;

        if (Check(M))
            R = M;
        else
            L = M;
    }

    printf("%.10Lf", R + R - td);

    return 0;
}
